﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SetsAndSubsets
{
    class Program
    {
        static void Main(string[] args)
        {
            List<int> universe = Console.ReadLine()
                                        .Split(',')
                                        .Select(x => int.Parse(x.Trim()))
                                        .ToList();

            int subsetCount = int.Parse(Console.ReadLine());
            List<List<int>> subsets = new List<List<int>>();

            for (int i = 0; i < subsetCount; i++)
            {
                List<int> subset = Console.ReadLine()
                                            .Split(',')
                                            .Select(x => int.Parse(x.Trim()))
                                            .ToList();
                subsets.Add(subset);
            }
            List<List<int>> selected = new List<List<int>>();


            List<int> unifiedSelected = Unify(selected);

            while (unifiedSelected.Count < universe.Count)
            {
                int priority = 0;
                List<int> currentHighest = null;

                foreach (var subset in subsets)
                {
                    int currentPriority = GetPriority(subset, universe.Except(unifiedSelected).ToList());
                    if (currentPriority > priority)
                    {
                        priority = currentPriority;
                        currentHighest = subset;
                    }
                }

                if (currentHighest != null)
                {
                    selected.Add(currentHighest);
                    subsets.Remove(currentHighest);
                    unifiedSelected = Unify(selected);
                }
                else
                {
                    break;
                }
            }

            Console.WriteLine(string.Join(", ", universe));
            Console.WriteLine($"Subsets: {selected.Count}");

            foreach (var sets in selected)
            {
                Console.WriteLine($"[{string.Join(", ", sets)}]");
            }

            Console.ReadLine();
        }

        static List<int> Unify(List<List<int>> subsets)
        {
            List<int> unified = new List<int>();

            foreach (var set in subsets)
            {
                unified.AddRange(set);
            }

            unified = unified.Distinct().ToList();
            unified.Sort();
            return unified;
        }

        static int GetPriority(List<int> subset, List<int> universe)
        {
            return universe.Intersect(subset).Count();
        }

    }
}
